pragma Ada_95;
pragma Warnings (Off);
pragma Source_File_Name (ada_main, Spec_File_Name => "b__templates2ada.ads");
pragma Source_File_Name (ada_main, Body_File_Name => "b__templates2ada.adb");
pragma Suppress (Overflow_Check);

with System.Restrictions;
with Ada.Exceptions;

package body ada_main is

   E014 : Short_Integer; pragma Import (Ada, E014, "system__soft_links_E");
   E018 : Short_Integer; pragma Import (Ada, E018, "system__secondary_stack_E");
   E012 : Short_Integer; pragma Import (Ada, E012, "system__exception_table_E");
   E026 : Short_Integer; pragma Import (Ada, E026, "system__exceptions_E");
   E061 : Short_Integer; pragma Import (Ada, E061, "ada__containers_E");
   E067 : Short_Integer; pragma Import (Ada, E067, "ada__io_exceptions_E");
   E009 : Short_Integer; pragma Import (Ada, E009, "ada__strings_E");
   E090 : Short_Integer; pragma Import (Ada, E090, "interfaces__c_E");
   E203 : Short_Integer; pragma Import (Ada, E203, "interfaces__c__strings_E");
   E142 : Short_Integer; pragma Import (Ada, E142, "system__os_lib_E");
   E219 : Short_Integer; pragma Import (Ada, E219, "system__task_info_E");
   E069 : Short_Integer; pragma Import (Ada, E069, "ada__tags_E");
   E066 : Short_Integer; pragma Import (Ada, E066, "ada__streams_E");
   E145 : Short_Integer; pragma Import (Ada, E145, "system__file_control_block_E");
   E081 : Short_Integer; pragma Import (Ada, E081, "system__finalization_root_E");
   E064 : Short_Integer; pragma Import (Ada, E064, "ada__finalization_E");
   E138 : Short_Integer; pragma Import (Ada, E138, "system__file_io_E");
   E149 : Short_Integer; pragma Import (Ada, E149, "ada__streams__stream_io_E");
   E129 : Short_Integer; pragma Import (Ada, E129, "system__storage_pools_E");
   E123 : Short_Integer; pragma Import (Ada, E123, "system__finalization_masters_E");
   E121 : Short_Integer; pragma Import (Ada, E121, "system__storage_pools__subpools_E");
   E088 : Short_Integer; pragma Import (Ada, E088, "ada__calendar_E");
   E096 : Short_Integer; pragma Import (Ada, E096, "ada__calendar__time_zones_E");
   E153 : Short_Integer; pragma Import (Ada, E153, "ada__text_io_E");
   E178 : Short_Integer; pragma Import (Ada, E178, "gnat__calendar_E");
   E054 : Short_Integer; pragma Import (Ada, E054, "ada__strings__maps_E");
   E058 : Short_Integer; pragma Import (Ada, E058, "ada__strings__maps__constants_E");
   E115 : Short_Integer; pragma Import (Ada, E115, "ada__strings__unbounded_E");
   E192 : Short_Integer; pragma Import (Ada, E192, "system__regpat_E");
   E181 : Short_Integer; pragma Import (Ada, E181, "gnat__calendar__time_io_E");
   E158 : Short_Integer; pragma Import (Ada, E158, "gnat__directory_operations_E");
   E161 : Short_Integer; pragma Import (Ada, E161, "system__pool_global_E");
   E147 : Short_Integer; pragma Import (Ada, E147, "system__regexp_E");
   E086 : Short_Integer; pragma Import (Ada, E086, "ada__directories_E");
   E156 : Short_Integer; pragma Import (Ada, E156, "gnat__command_line_E");
   E233 : Short_Integer; pragma Import (Ada, E233, "system__tasking__initialization_E");
   E243 : Short_Integer; pragma Import (Ada, E243, "system__tasking__protected_objects_E");
   E247 : Short_Integer; pragma Import (Ada, E247, "system__tasking__protected_objects__entries_E");
   E241 : Short_Integer; pragma Import (Ada, E241, "system__tasking__queuing_E");
   E205 : Short_Integer; pragma Import (Ada, E205, "templates_parser_tasking_E");
   E169 : Short_Integer; pragma Import (Ada, E169, "templates_parser_E");
   E199 : Short_Integer; pragma Import (Ada, E199, "templates_parser__utils_E");
   E197 : Short_Integer; pragma Import (Ada, E197, "templates_parser__input_E");

   Local_Priority_Specific_Dispatching : constant String := "";
   Local_Interrupt_States : constant String := "";

   Is_Elaborated : Boolean := False;

   procedure finalize_library is
   begin
      declare
         procedure F1;
         pragma Import (Ada, F1, "templates_parser__finalize_body");
      begin
         E169 := E169 - 1;
         F1;
      end;
      declare
         procedure F2;
         pragma Import (Ada, F2, "templates_parser__finalize_spec");
      begin
         F2;
      end;
      declare
         procedure F3;
         pragma Import (Ada, F3, "templates_parser_tasking__finalize_body");
      begin
         E205 := E205 - 1;
         F3;
      end;
      E247 := E247 - 1;
      declare
         procedure F4;
         pragma Import (Ada, F4, "system__tasking__protected_objects__entries__finalize_spec");
      begin
         F4;
      end;
      E086 := E086 - 1;
      declare
         procedure F5;
         pragma Import (Ada, F5, "ada__directories__finalize_spec");
      begin
         F5;
      end;
      E147 := E147 - 1;
      declare
         procedure F6;
         pragma Import (Ada, F6, "system__regexp__finalize_spec");
      begin
         F6;
      end;
      E161 := E161 - 1;
      declare
         procedure F7;
         pragma Import (Ada, F7, "system__pool_global__finalize_spec");
      begin
         F7;
      end;
      E115 := E115 - 1;
      declare
         procedure F8;
         pragma Import (Ada, F8, "ada__strings__unbounded__finalize_spec");
      begin
         F8;
      end;
      E153 := E153 - 1;
      declare
         procedure F9;
         pragma Import (Ada, F9, "ada__text_io__finalize_spec");
      begin
         F9;
      end;
      E121 := E121 - 1;
      declare
         procedure F10;
         pragma Import (Ada, F10, "system__storage_pools__subpools__finalize_spec");
      begin
         F10;
      end;
      E123 := E123 - 1;
      declare
         procedure F11;
         pragma Import (Ada, F11, "system__finalization_masters__finalize_spec");
      begin
         F11;
      end;
      E149 := E149 - 1;
      declare
         procedure F12;
         pragma Import (Ada, F12, "ada__streams__stream_io__finalize_spec");
      begin
         F12;
      end;
      declare
         procedure F13;
         pragma Import (Ada, F13, "system__file_io__finalize_body");
      begin
         E138 := E138 - 1;
         F13;
      end;
      declare
         procedure Reraise_Library_Exception_If_Any;
            pragma Import (Ada, Reraise_Library_Exception_If_Any, "__gnat_reraise_library_exception_if_any");
      begin
         Reraise_Library_Exception_If_Any;
      end;
   end finalize_library;

   procedure adafinal is
      procedure s_stalib_adafinal;
      pragma Import (C, s_stalib_adafinal, "system__standard_library__adafinal");

      procedure Runtime_Finalize;
      pragma Import (C, Runtime_Finalize, "__gnat_runtime_finalize");

   begin
      if not Is_Elaborated then
         return;
      end if;
      Is_Elaborated := False;
      Runtime_Finalize;
      s_stalib_adafinal;
   end adafinal;

   type No_Param_Proc is access procedure;

   procedure adainit is
      Main_Priority : Integer;
      pragma Import (C, Main_Priority, "__gl_main_priority");
      Time_Slice_Value : Integer;
      pragma Import (C, Time_Slice_Value, "__gl_time_slice_val");
      WC_Encoding : Character;
      pragma Import (C, WC_Encoding, "__gl_wc_encoding");
      Locking_Policy : Character;
      pragma Import (C, Locking_Policy, "__gl_locking_policy");
      Queuing_Policy : Character;
      pragma Import (C, Queuing_Policy, "__gl_queuing_policy");
      Task_Dispatching_Policy : Character;
      pragma Import (C, Task_Dispatching_Policy, "__gl_task_dispatching_policy");
      Priority_Specific_Dispatching : System.Address;
      pragma Import (C, Priority_Specific_Dispatching, "__gl_priority_specific_dispatching");
      Num_Specific_Dispatching : Integer;
      pragma Import (C, Num_Specific_Dispatching, "__gl_num_specific_dispatching");
      Main_CPU : Integer;
      pragma Import (C, Main_CPU, "__gl_main_cpu");
      Interrupt_States : System.Address;
      pragma Import (C, Interrupt_States, "__gl_interrupt_states");
      Num_Interrupt_States : Integer;
      pragma Import (C, Num_Interrupt_States, "__gl_num_interrupt_states");
      Unreserve_All_Interrupts : Integer;
      pragma Import (C, Unreserve_All_Interrupts, "__gl_unreserve_all_interrupts");
      Exception_Tracebacks : Integer;
      pragma Import (C, Exception_Tracebacks, "__gl_exception_tracebacks");
      Detect_Blocking : Integer;
      pragma Import (C, Detect_Blocking, "__gl_detect_blocking");
      Default_Stack_Size : Integer;
      pragma Import (C, Default_Stack_Size, "__gl_default_stack_size");
      Leap_Seconds_Support : Integer;
      pragma Import (C, Leap_Seconds_Support, "__gl_leap_seconds_support");
      Bind_Env_Addr : System.Address;
      pragma Import (C, Bind_Env_Addr, "__gl_bind_env_addr");

      procedure Runtime_Initialize (Install_Handler : Integer);
      pragma Import (C, Runtime_Initialize, "__gnat_runtime_initialize");

      Finalize_Library_Objects : No_Param_Proc;
      pragma Import (C, Finalize_Library_Objects, "__gnat_finalize_library_objects");
   begin
      if Is_Elaborated then
         return;
      end if;
      Is_Elaborated := True;
      Main_Priority := -1;
      Time_Slice_Value := -1;
      WC_Encoding := 'b';
      Locking_Policy := ' ';
      Queuing_Policy := ' ';
      Task_Dispatching_Policy := ' ';
      System.Restrictions.Run_Time_Restrictions :=
        (Set =>
          (False, False, False, False, False, False, False, False, 
           False, False, False, False, False, False, False, False, 
           False, False, False, False, False, False, False, False, 
           False, False, False, False, False, False, False, False, 
           False, False, False, False, False, False, False, False, 
           False, False, False, False, False, False, False, False, 
           False, False, False, False, False, False, False, False, 
           False, False, False, False, False, False, False, False, 
           False, False, False, False, False, False, False, False, 
           False, False, False, False, True, False, False, False, 
           False, False, False, False, False, False, False, False, 
           False, False, False),
         Value => (0, 0, 0, 0, 0, 0, 0, 0, 0, 0),
         Violated =>
          (True, False, False, True, True, False, False, True, 
           False, False, True, True, True, True, False, False, 
           True, False, False, True, True, False, True, True, 
           False, True, True, True, True, False, True, False, 
           False, False, True, False, False, True, False, True, 
           False, True, True, False, False, True, True, False, 
           False, True, True, False, True, False, False, False, 
           False, False, False, False, True, True, True, False, 
           False, True, False, True, True, True, False, True, 
           True, False, True, True, True, True, False, False, 
           True, False, False, False, True, False, False, False, 
           False, True, False),
         Count => (0, 0, 0, 2, 0, 0, 0, 0, 1, 0),
         Unknown => (False, False, False, False, False, False, False, False, True, False));
      Priority_Specific_Dispatching :=
        Local_Priority_Specific_Dispatching'Address;
      Num_Specific_Dispatching := 0;
      Main_CPU := -1;
      Interrupt_States := Local_Interrupt_States'Address;
      Num_Interrupt_States := 0;
      Unreserve_All_Interrupts := 0;
      Exception_Tracebacks := 1;
      Detect_Blocking := 0;
      Default_Stack_Size := -1;
      Leap_Seconds_Support := 0;

      Runtime_Initialize (1);

      Finalize_Library_Objects := finalize_library'access;

      System.Soft_Links'Elab_Spec;
      System.Soft_Links'Elab_Body;
      E014 := E014 + 1;
      System.Exception_Table'Elab_Body;
      E012 := E012 + 1;
      System.Exceptions'Elab_Spec;
      E026 := E026 + 1;
      System.Secondary_Stack'Elab_Body;
      E018 := E018 + 1;
      Ada.Containers'Elab_Spec;
      E061 := E061 + 1;
      Ada.Io_Exceptions'Elab_Spec;
      E067 := E067 + 1;
      Ada.Strings'Elab_Spec;
      E009 := E009 + 1;
      Interfaces.C'Elab_Spec;
      E090 := E090 + 1;
      Interfaces.C.Strings'Elab_Spec;
      E203 := E203 + 1;
      System.Os_Lib'Elab_Body;
      E142 := E142 + 1;
      System.Task_Info'Elab_Spec;
      E219 := E219 + 1;
      Ada.Tags'Elab_Spec;
      Ada.Tags'Elab_Body;
      E069 := E069 + 1;
      Ada.Streams'Elab_Spec;
      E066 := E066 + 1;
      System.File_Control_Block'Elab_Spec;
      E145 := E145 + 1;
      System.Finalization_Root'Elab_Spec;
      E081 := E081 + 1;
      Ada.Finalization'Elab_Spec;
      E064 := E064 + 1;
      System.File_Io'Elab_Body;
      E138 := E138 + 1;
      Ada.Streams.Stream_Io'Elab_Spec;
      E149 := E149 + 1;
      System.Storage_Pools'Elab_Spec;
      E129 := E129 + 1;
      System.Finalization_Masters'Elab_Spec;
      System.Finalization_Masters'Elab_Body;
      E123 := E123 + 1;
      System.Storage_Pools.Subpools'Elab_Spec;
      E121 := E121 + 1;
      Ada.Calendar'Elab_Spec;
      Ada.Calendar'Elab_Body;
      E088 := E088 + 1;
      Ada.Calendar.Time_Zones'Elab_Spec;
      E096 := E096 + 1;
      Ada.Text_Io'Elab_Spec;
      Ada.Text_Io'Elab_Body;
      E153 := E153 + 1;
      Gnat.Calendar'Elab_Spec;
      E178 := E178 + 1;
      Ada.Strings.Maps'Elab_Spec;
      E054 := E054 + 1;
      Ada.Strings.Maps.Constants'Elab_Spec;
      E058 := E058 + 1;
      Ada.Strings.Unbounded'Elab_Spec;
      E115 := E115 + 1;
      System.Regpat'Elab_Spec;
      E192 := E192 + 1;
      Gnat.Calendar.Time_Io'Elab_Spec;
      E181 := E181 + 1;
      Gnat.Directory_Operations'Elab_Spec;
      Gnat.Directory_Operations'Elab_Body;
      E158 := E158 + 1;
      System.Pool_Global'Elab_Spec;
      E161 := E161 + 1;
      System.Regexp'Elab_Spec;
      E147 := E147 + 1;
      Ada.Directories'Elab_Spec;
      Ada.Directories'Elab_Body;
      E086 := E086 + 1;
      Gnat.Command_Line'Elab_Spec;
      Gnat.Command_Line'Elab_Body;
      E156 := E156 + 1;
      System.Tasking.Initialization'Elab_Body;
      E233 := E233 + 1;
      System.Tasking.Protected_Objects'Elab_Body;
      E243 := E243 + 1;
      System.Tasking.Protected_Objects.Entries'Elab_Spec;
      E247 := E247 + 1;
      System.Tasking.Queuing'Elab_Body;
      E241 := E241 + 1;
      Templates_Parser_Tasking'Elab_Body;
      E205 := E205 + 1;
      Templates_Parser'Elab_Spec;
      Templates_Parser.Utils'Elab_Spec;
      E199 := E199 + 1;
      Templates_Parser.Input'Elab_Spec;
      E197 := E197 + 1;
      Templates_Parser'Elab_Body;
      E169 := E169 + 1;
   end adainit;

   procedure Ada_Main_Program;
   pragma Import (Ada, Ada_Main_Program, "_ada_templates2ada");

   function main
     (argc : Integer;
      argv : System.Address;
      envp : System.Address)
      return Integer
   is
      procedure Initialize (Addr : System.Address);
      pragma Import (C, Initialize, "__gnat_initialize");

      procedure Finalize;
      pragma Import (C, Finalize, "__gnat_finalize");
      SEH : aliased array (1 .. 2) of Integer;

      Ensure_Reference : aliased System.Address := Ada_Main_Program_Name'Address;
      pragma Volatile (Ensure_Reference);

   begin
      gnat_argc := argc;
      gnat_argv := argv;
      gnat_envp := envp;

      Initialize (SEH'Address);
      adainit;
      Ada_Main_Program;
      adafinal;
      Finalize;
      return (gnat_exit_status);
   end;

--  BEGIN Object file/option list
   --   /builddir/build/BUILD/templates_parser-11.8.0/.build/x86_64-redhat-linux/release/relocatable/tobj/templates2ada.o
   --   -L/builddir/build/BUILD/templates_parser-11.8.0/.build/x86_64-redhat-linux/release/relocatable/tobj/
   --   -L/builddir/build/BUILD/templates_parser-11.8.0/.build/x86_64-redhat-linux/release/relocatable/tobj/
   --   -L/builddir/build/BUILD/templates_parser-11.8.0/.build/x86_64-redhat-linux/release/relocatable/lib/
   --   -L/usr/lib/gcc/x86_64-redhat-linux/7/adalib/
   --   -shared
   --   -lgnarl-7
   --   -lgnat-7
   --   -lpthread
   --   -lrt
--  END Object file/option list   

end ada_main;
