pragma Ada_95;
pragma Warnings (Off);
pragma Source_File_Name (ada_main, Spec_File_Name => "b__templatespp.ads");
pragma Source_File_Name (ada_main, Body_File_Name => "b__templatespp.adb");
pragma Suppress (Overflow_Check);

with System.Restrictions;
with Ada.Exceptions;

package body ada_main is

   E013 : Short_Integer; pragma Import (Ada, E013, "system__soft_links_E");
   E019 : Short_Integer; pragma Import (Ada, E019, "system__exception_table_E");
   E021 : Short_Integer; pragma Import (Ada, E021, "system__exceptions_E");
   E009 : Short_Integer; pragma Import (Ada, E009, "system__secondary_stack_E");
   E143 : Short_Integer; pragma Import (Ada, E143, "ada__containers_E");
   E089 : Short_Integer; pragma Import (Ada, E089, "ada__io_exceptions_E");
   E050 : Short_Integer; pragma Import (Ada, E050, "ada__strings_E");
   E108 : Short_Integer; pragma Import (Ada, E108, "interfaces__c_E");
   E202 : Short_Integer; pragma Import (Ada, E202, "interfaces__c__strings_E");
   E110 : Short_Integer; pragma Import (Ada, E110, "system__os_lib_E");
   E218 : Short_Integer; pragma Import (Ada, E218, "system__task_info_E");
   E063 : Short_Integer; pragma Import (Ada, E063, "ada__tags_E");
   E088 : Short_Integer; pragma Import (Ada, E088, "ada__streams_E");
   E113 : Short_Integer; pragma Import (Ada, E113, "system__file_control_block_E");
   E091 : Short_Integer; pragma Import (Ada, E091, "system__finalization_root_E");
   E086 : Short_Integer; pragma Import (Ada, E086, "ada__finalization_E");
   E106 : Short_Integer; pragma Import (Ada, E106, "system__file_io_E");
   E185 : Short_Integer; pragma Import (Ada, E185, "ada__streams__stream_io_E");
   E093 : Short_Integer; pragma Import (Ada, E093, "system__storage_pools_E");
   E081 : Short_Integer; pragma Import (Ada, E081, "system__finalization_masters_E");
   E079 : Short_Integer; pragma Import (Ada, E079, "system__storage_pools__subpools_E");
   E140 : Short_Integer; pragma Import (Ada, E140, "ada__calendar_E");
   E159 : Short_Integer; pragma Import (Ada, E159, "ada__calendar__time_zones_E");
   E101 : Short_Integer; pragma Import (Ada, E101, "ada__text_io_E");
   E154 : Short_Integer; pragma Import (Ada, E154, "gnat__calendar_E");
   E056 : Short_Integer; pragma Import (Ada, E056, "ada__strings__maps_E");
   E119 : Short_Integer; pragma Import (Ada, E119, "ada__strings__maps__constants_E");
   E052 : Short_Integer; pragma Import (Ada, E052, "ada__strings__unbounded_E");
   E179 : Short_Integer; pragma Import (Ada, E179, "system__regpat_E");
   E168 : Short_Integer; pragma Import (Ada, E168, "gnat__calendar__time_io_E");
   E121 : Short_Integer; pragma Import (Ada, E121, "gnat__directory_operations_E");
   E126 : Short_Integer; pragma Import (Ada, E126, "system__pool_global_E");
   E135 : Short_Integer; pragma Import (Ada, E135, "system__regexp_E");
   E194 : Short_Integer; pragma Import (Ada, E194, "ada__directories_E");
   E116 : Short_Integer; pragma Import (Ada, E116, "gnat__command_line_E");
   E232 : Short_Integer; pragma Import (Ada, E232, "system__tasking__initialization_E");
   E242 : Short_Integer; pragma Import (Ada, E242, "system__tasking__protected_objects_E");
   E246 : Short_Integer; pragma Import (Ada, E246, "system__tasking__protected_objects__entries_E");
   E240 : Short_Integer; pragma Import (Ada, E240, "system__tasking__queuing_E");
   E204 : Short_Integer; pragma Import (Ada, E204, "templates_parser_tasking_E");
   E138 : Short_Integer; pragma Import (Ada, E138, "templates_parser_E");
   E192 : Short_Integer; pragma Import (Ada, E192, "templates_parser__utils_E");
   E190 : Short_Integer; pragma Import (Ada, E190, "templates_parser__input_E");

   Local_Priority_Specific_Dispatching : constant String := "";
   Local_Interrupt_States : constant String := "";

   Is_Elaborated : Boolean := False;

   procedure finalize_library is
   begin
      declare
         procedure F1;
         pragma Import (Ada, F1, "templates_parser__finalize_body");
      begin
         E138 := E138 - 1;
         F1;
      end;
      declare
         procedure F2;
         pragma Import (Ada, F2, "templates_parser__finalize_spec");
      begin
         F2;
      end;
      declare
         procedure F3;
         pragma Import (Ada, F3, "templates_parser_tasking__finalize_body");
      begin
         E204 := E204 - 1;
         F3;
      end;
      E246 := E246 - 1;
      declare
         procedure F4;
         pragma Import (Ada, F4, "system__tasking__protected_objects__entries__finalize_spec");
      begin
         F4;
      end;
      E194 := E194 - 1;
      declare
         procedure F5;
         pragma Import (Ada, F5, "ada__directories__finalize_spec");
      begin
         F5;
      end;
      E135 := E135 - 1;
      declare
         procedure F6;
         pragma Import (Ada, F6, "system__regexp__finalize_spec");
      begin
         F6;
      end;
      E126 := E126 - 1;
      declare
         procedure F7;
         pragma Import (Ada, F7, "system__pool_global__finalize_spec");
      begin
         F7;
      end;
      E052 := E052 - 1;
      declare
         procedure F8;
         pragma Import (Ada, F8, "ada__strings__unbounded__finalize_spec");
      begin
         F8;
      end;
      E101 := E101 - 1;
      declare
         procedure F9;
         pragma Import (Ada, F9, "ada__text_io__finalize_spec");
      begin
         F9;
      end;
      E079 := E079 - 1;
      declare
         procedure F10;
         pragma Import (Ada, F10, "system__storage_pools__subpools__finalize_spec");
      begin
         F10;
      end;
      E081 := E081 - 1;
      declare
         procedure F11;
         pragma Import (Ada, F11, "system__finalization_masters__finalize_spec");
      begin
         F11;
      end;
      E185 := E185 - 1;
      declare
         procedure F12;
         pragma Import (Ada, F12, "ada__streams__stream_io__finalize_spec");
      begin
         F12;
      end;
      declare
         procedure F13;
         pragma Import (Ada, F13, "system__file_io__finalize_body");
      begin
         E106 := E106 - 1;
         F13;
      end;
      declare
         procedure Reraise_Library_Exception_If_Any;
            pragma Import (Ada, Reraise_Library_Exception_If_Any, "__gnat_reraise_library_exception_if_any");
      begin
         Reraise_Library_Exception_If_Any;
      end;
   end finalize_library;

   procedure adafinal is
      procedure s_stalib_adafinal;
      pragma Import (C, s_stalib_adafinal, "system__standard_library__adafinal");

      procedure Runtime_Finalize;
      pragma Import (C, Runtime_Finalize, "__gnat_runtime_finalize");

   begin
      if not Is_Elaborated then
         return;
      end if;
      Is_Elaborated := False;
      Runtime_Finalize;
      s_stalib_adafinal;
   end adafinal;

   type No_Param_Proc is access procedure;

   procedure adainit is
      Main_Priority : Integer;
      pragma Import (C, Main_Priority, "__gl_main_priority");
      Time_Slice_Value : Integer;
      pragma Import (C, Time_Slice_Value, "__gl_time_slice_val");
      WC_Encoding : Character;
      pragma Import (C, WC_Encoding, "__gl_wc_encoding");
      Locking_Policy : Character;
      pragma Import (C, Locking_Policy, "__gl_locking_policy");
      Queuing_Policy : Character;
      pragma Import (C, Queuing_Policy, "__gl_queuing_policy");
      Task_Dispatching_Policy : Character;
      pragma Import (C, Task_Dispatching_Policy, "__gl_task_dispatching_policy");
      Priority_Specific_Dispatching : System.Address;
      pragma Import (C, Priority_Specific_Dispatching, "__gl_priority_specific_dispatching");
      Num_Specific_Dispatching : Integer;
      pragma Import (C, Num_Specific_Dispatching, "__gl_num_specific_dispatching");
      Main_CPU : Integer;
      pragma Import (C, Main_CPU, "__gl_main_cpu");
      Interrupt_States : System.Address;
      pragma Import (C, Interrupt_States, "__gl_interrupt_states");
      Num_Interrupt_States : Integer;
      pragma Import (C, Num_Interrupt_States, "__gl_num_interrupt_states");
      Unreserve_All_Interrupts : Integer;
      pragma Import (C, Unreserve_All_Interrupts, "__gl_unreserve_all_interrupts");
      Exception_Tracebacks : Integer;
      pragma Import (C, Exception_Tracebacks, "__gl_exception_tracebacks");
      Detect_Blocking : Integer;
      pragma Import (C, Detect_Blocking, "__gl_detect_blocking");
      Default_Stack_Size : Integer;
      pragma Import (C, Default_Stack_Size, "__gl_default_stack_size");
      Leap_Seconds_Support : Integer;
      pragma Import (C, Leap_Seconds_Support, "__gl_leap_seconds_support");
      Bind_Env_Addr : System.Address;
      pragma Import (C, Bind_Env_Addr, "__gl_bind_env_addr");

      procedure Runtime_Initialize (Install_Handler : Integer);
      pragma Import (C, Runtime_Initialize, "__gnat_runtime_initialize");

      Finalize_Library_Objects : No_Param_Proc;
      pragma Import (C, Finalize_Library_Objects, "__gnat_finalize_library_objects");
   begin
      if Is_Elaborated then
         return;
      end if;
      Is_Elaborated := True;
      Main_Priority := -1;
      Time_Slice_Value := -1;
      WC_Encoding := 'b';
      Locking_Policy := ' ';
      Queuing_Policy := ' ';
      Task_Dispatching_Policy := ' ';
      System.Restrictions.Run_Time_Restrictions :=
        (Set =>
          (False, False, False, False, False, False, False, False, 
           False, False, False, False, False, False, False, False, 
           False, False, False, False, False, False, False, False, 
           False, False, False, False, False, False, False, False, 
           False, False, False, False, False, False, False, False, 
           False, False, False, False, False, False, False, False, 
           False, False, False, False, False, False, False, False, 
           False, False, False, False, False, False, False, False, 
           False, False, False, False, False, False, False, False, 
           False, False, False, False, True, False, False, False, 
           False, False, False, False, False, False, False, False, 
           False, False, False),
         Value => (0, 0, 0, 0, 0, 0, 0, 0, 0, 0),
         Violated =>
          (True, False, False, True, True, False, False, True, 
           False, False, True, True, True, True, False, False, 
           True, False, False, True, True, False, True, True, 
           False, True, True, True, True, False, True, False, 
           False, False, True, False, False, True, False, True, 
           False, True, True, False, False, True, True, False, 
           False, False, True, False, True, False, False, False, 
           False, False, False, False, True, True, True, False, 
           False, True, False, True, True, True, False, True, 
           True, False, True, True, True, True, False, False, 
           True, False, False, False, True, False, False, False, 
           False, True, False),
         Count => (0, 0, 0, 2, 0, 0, 0, 0, 1, 0),
         Unknown => (False, False, False, False, False, False, False, False, True, False));
      Priority_Specific_Dispatching :=
        Local_Priority_Specific_Dispatching'Address;
      Num_Specific_Dispatching := 0;
      Main_CPU := -1;
      Interrupt_States := Local_Interrupt_States'Address;
      Num_Interrupt_States := 0;
      Unreserve_All_Interrupts := 0;
      Exception_Tracebacks := 1;
      Detect_Blocking := 0;
      Default_Stack_Size := -1;
      Leap_Seconds_Support := 0;

      Runtime_Initialize (1);

      Finalize_Library_Objects := finalize_library'access;

      System.Soft_Links'Elab_Spec;
      System.Exception_Table'Elab_Body;
      E019 := E019 + 1;
      System.Exceptions'Elab_Spec;
      E021 := E021 + 1;
      System.Soft_Links'Elab_Body;
      E013 := E013 + 1;
      System.Secondary_Stack'Elab_Body;
      E009 := E009 + 1;
      Ada.Containers'Elab_Spec;
      E143 := E143 + 1;
      Ada.Io_Exceptions'Elab_Spec;
      E089 := E089 + 1;
      Ada.Strings'Elab_Spec;
      E050 := E050 + 1;
      Interfaces.C'Elab_Spec;
      E108 := E108 + 1;
      Interfaces.C.Strings'Elab_Spec;
      E202 := E202 + 1;
      System.Os_Lib'Elab_Body;
      E110 := E110 + 1;
      System.Task_Info'Elab_Spec;
      E218 := E218 + 1;
      Ada.Tags'Elab_Spec;
      Ada.Tags'Elab_Body;
      E063 := E063 + 1;
      Ada.Streams'Elab_Spec;
      E088 := E088 + 1;
      System.File_Control_Block'Elab_Spec;
      E113 := E113 + 1;
      System.Finalization_Root'Elab_Spec;
      E091 := E091 + 1;
      Ada.Finalization'Elab_Spec;
      E086 := E086 + 1;
      System.File_Io'Elab_Body;
      E106 := E106 + 1;
      Ada.Streams.Stream_Io'Elab_Spec;
      E185 := E185 + 1;
      System.Storage_Pools'Elab_Spec;
      E093 := E093 + 1;
      System.Finalization_Masters'Elab_Spec;
      System.Finalization_Masters'Elab_Body;
      E081 := E081 + 1;
      System.Storage_Pools.Subpools'Elab_Spec;
      E079 := E079 + 1;
      Ada.Calendar'Elab_Spec;
      Ada.Calendar'Elab_Body;
      E140 := E140 + 1;
      Ada.Calendar.Time_Zones'Elab_Spec;
      E159 := E159 + 1;
      Ada.Text_Io'Elab_Spec;
      Ada.Text_Io'Elab_Body;
      E101 := E101 + 1;
      Gnat.Calendar'Elab_Spec;
      E154 := E154 + 1;
      Ada.Strings.Maps'Elab_Spec;
      E056 := E056 + 1;
      Ada.Strings.Maps.Constants'Elab_Spec;
      E119 := E119 + 1;
      Ada.Strings.Unbounded'Elab_Spec;
      E052 := E052 + 1;
      System.Regpat'Elab_Spec;
      E179 := E179 + 1;
      Gnat.Calendar.Time_Io'Elab_Spec;
      E168 := E168 + 1;
      Gnat.Directory_Operations'Elab_Spec;
      Gnat.Directory_Operations'Elab_Body;
      E121 := E121 + 1;
      System.Pool_Global'Elab_Spec;
      E126 := E126 + 1;
      System.Regexp'Elab_Spec;
      E135 := E135 + 1;
      Ada.Directories'Elab_Spec;
      Ada.Directories'Elab_Body;
      E194 := E194 + 1;
      Gnat.Command_Line'Elab_Spec;
      Gnat.Command_Line'Elab_Body;
      E116 := E116 + 1;
      System.Tasking.Initialization'Elab_Body;
      E232 := E232 + 1;
      System.Tasking.Protected_Objects'Elab_Body;
      E242 := E242 + 1;
      System.Tasking.Protected_Objects.Entries'Elab_Spec;
      E246 := E246 + 1;
      System.Tasking.Queuing'Elab_Body;
      E240 := E240 + 1;
      Templates_Parser_Tasking'Elab_Body;
      E204 := E204 + 1;
      Templates_Parser'Elab_Spec;
      Templates_Parser.Utils'Elab_Spec;
      E192 := E192 + 1;
      Templates_Parser.Input'Elab_Spec;
      E190 := E190 + 1;
      Templates_Parser'Elab_Body;
      E138 := E138 + 1;
   end adainit;

   procedure Ada_Main_Program;
   pragma Import (Ada, Ada_Main_Program, "_ada_templatespp");

   function main
     (argc : Integer;
      argv : System.Address;
      envp : System.Address)
      return Integer
   is
      procedure Initialize (Addr : System.Address);
      pragma Import (C, Initialize, "__gnat_initialize");

      procedure Finalize;
      pragma Import (C, Finalize, "__gnat_finalize");
      SEH : aliased array (1 .. 2) of Integer;

      Ensure_Reference : aliased System.Address := Ada_Main_Program_Name'Address;
      pragma Volatile (Ensure_Reference);

   begin
      gnat_argc := argc;
      gnat_argv := argv;
      gnat_envp := envp;

      Initialize (SEH'Address);
      adainit;
      Ada_Main_Program;
      adafinal;
      Finalize;
      return (gnat_exit_status);
   end;

--  BEGIN Object file/option list
   --   /builddir/build/BUILD/templates_parser-11.8.0/.build/x86_64-redhat-linux/release/relocatable/tobj/templatespp.o
   --   -L/builddir/build/BUILD/templates_parser-11.8.0/.build/x86_64-redhat-linux/release/relocatable/tobj/
   --   -L/builddir/build/BUILD/templates_parser-11.8.0/.build/x86_64-redhat-linux/release/relocatable/tobj/
   --   -L/builddir/build/BUILD/templates_parser-11.8.0/.build/x86_64-redhat-linux/release/relocatable/lib/
   --   -L/usr/lib/gcc/x86_64-redhat-linux/7/adalib/
   --   -shared
   --   -lgnarl-7
   --   -lgnat-7
   --   -lpthread
   --   -lrt
--  END Object file/option list   

end ada_main;
